<template>
  <div class="oboz-middle-menu">
    <div
      ref="middleMenuContainer"
      class="middle-menu-container"
      :class="{'middle-menu-container-loading': loading}"
    >
      <div
        ref="menuContainer"
        class="menu-container"
      >
        <template
          v-for="(member, index) in calculatedMenu"
        >
          <template
            v-if="(member.width < documentWidth || member.width == undefined) && (member.title || member.border)"
          >
            <ob-menu-button
              v-if="member.code"
              :key="index"
              :title="member.title"
              :to="{name: member.code}"
              :data-qa="member.code"
              :class="'--level-' + member.level"
            />
            <div
              v-else-if="member.border"
              :key="index"
              class="border-container"
              :data-qa="member.code"
            >
              <hr class="border">
            </div>
            <div
              v-else
              :key="index"
              class="oboz-menu-level-2"
              :data-qa="member.code"
            >
              {{ member.title }}
            </div>
          </template>
        </template>
        <div
          v-if="dropdownMembers.length"
          :items="dropdownMembers"
          class="hidden-items"
        >
          <span
            class="hidden-items__label"
            :data-qa="dataQa"
            @click="toggleMore"
          >
            Еще
            <i
              class="icon"
              :class="isMoreOpen ? 'chevron-up' : 'chevron-down'"
            />
          </span>
          <select-dropdown
            v-show="isMoreOpen"
            ref="popper"
            v-model="isMoreOpen"
            data-attr="ob-selector"
            position="bottom"
            :data-qa="dataQa"
          >
            <div class="hidden-items__container">
              <div
                v-for="(member, index) in dropdownMembers"
                :key="index"
                class="hidden-items__container-row"
                :data-qa="dataQa"
                @click="go(member)"
              >
                {{ member.title }}
              </div>
            </div>
          </select-dropdown>
        </div>
      </div>
      <div class="controls-container">
        <div
          v-for="item in controls"
          :key="item.code"
          class="controls-container__item"
        >
          <ObButton
            v-if="!item.items"
            :label="item.title"
            :to="{name: item.code, params:{id: item.action}}"
            :mini="true"
            type="primary-success"
            :data-qa="dataQa"
          />
          <ObMenuDropdown
            v-else
            :items="item.items"
            :is-none-button-style="true"
          >
            <template slot="button">
              <ObButton
                :label="item.title"
                :mini="true"
                type="primary-success"
                :data-qa="dataQa"
              />
            </template>
          </ObMenuDropdown>
        </div>
      </div>
    </div>
    <div class="oboz-middle-menu__right">
      <template v-if="isRoutePlomba">
        <router-link :to="{ name: 'plomba-payments' }">
          Лицевой счет:
        </router-link>
        <span class="bill-info">{{ user && user.balance && user.balance / 100 || 0 | formatNumber }} ₽</span>
      </template>
    </div>
  </div>
</template>
<script>
import ObMenuButton from './ObMenuButton.vue'
import ObButton from '../../obButton'
import SelectDropdown from '../../obSelect/select-dropdown'
import ObMenuDropdown from '../../obMenuDropdown'

export default {
  components: {
    ObMenuButton,
    SelectDropdown,
    ObButton,
    ObMenuDropdown
  },
  provide () {
    return {
      select: this
    }
  },
  menuCaption: 'Администрирование',
  props: {
    middleMenu: Array,
    controls: {
      type: Array,
      default: () => []
    },
    user: {
      type: Object,
      default: () => {}
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      calculatedMenu: [],
      documentWidth: 0,
      isMoreOpen: false,
      loading: true
    }
  },
  computed: {
    isRoutePlomba () {
      return this.$route.name && this.$route.name.includes('plomba')
    },
    dropdownMembers () {
      return this.calculatedMenu.filter(member => {
        return member.width >= this.documentWidth && !member.need_show_parent_only
      }).map(item => {
        return { ...item, ...{ to: { name: item.code } } }
      })
    }
  },
  watch: {
    middleMenu (to) {
      this.initMenu(to)
    }
  },
  mounted () {
    this.initMenu(this.middleMenu)
    window.addEventListener('resize', this.handleResize)
  },
  beforeDestroy () {
    window.removeEventListener('resize', this.handleResize)
  },
  methods: {
    async initMenu (to) {
      this.loading = true
      await this.delay(200)
      this.calculatedMenu = to.filter(item => !item.need_show_parent_only).map(i => ({ ...i, ...{ width: undefined } }))
      this.documentWidth = this.$refs.menuContainer.clientWidth - 60
      await this.delay(10)
      this.calcWidth()
      await this.delay(50)
      this.loading = false
    },
    async delay (d) {
      setTimeout(() => {
        return true
      }, d)
    },
    toggleMore () {
      this.isMoreOpen = !this.isMoreOpen
    },
    handleResize () {
      this.documentWidth = this.$refs.menuContainer.clientWidth - 60
    },
    calcWidth () {
      this.$refs.menuContainer.childNodes.forEach((node, ind) => {
        if (this.calculatedMenu[ind]) {
          this.calculatedMenu[ind].width = node.offsetLeft + node.offsetWidth
        }
      })
    },
    go (member) {
      this.$router.push({ name: member.code })
      this.isMoreOpen = false
    }
  }
}
</script>

<style
  scoped
  lang="scss"
>
  @import "../../../static/css/variables";
  .middle-menu-container {
    width: 100%;
    display: flex;
    justify-content: space-between;
    transition: opacity .2s;
    &-loading {
      opacity: 0
    }

    .menu-container {
      flex-grow: 2;
      display: flex;
      align-items: center;
      button {
        height: 100%;
      }
    }

    .controls-container {
      margin-left: 20px;
      display: flex;
      align-items: center;
      &__item + .controls-container__item {
        margin-left: 9px;
      }
    }
  }
  .border-container {
    display: flex;
    margin-right: 15px;
  }
  .border {
    margin-top: 8px;
    width: 1px;
    height: 24px;
    background: white;
    opacity: .6;
  }
  .oboz-menu-level-2 {
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin-left: 18px;
    margin-right: 15px;
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 12px;
    line-height: 16px;
    letter-spacing: 0.4px;
    text-transform: uppercase;
    color: $lavender;
    &::v-deep {
      .ob-button-container {
        height: 26px;
      }
    }
  }
  .oboz-middle-menu {
    position: relative;
    z-index: 10;
    display: flex;
    flex-wrap: wrap;
    align-self: stretch;
    justify-content: flex-start;
    flex-direction: row;
    width: auto;
    height: 40px;
    padding-right: 20px;
    box-shadow: 0 4px 16px rgba($color-blue-navy-blue, 0.4);
    padding-left: 128px;
    &__right {
      text-transform: uppercase;
      color: $obMainMenu-middle_right !important;
      font-size: 12px;
      line-height: 15px;
      letter-spacing: 0.8px;
      .bill-info {
        font-weight: 500;
        font-size: 1.4em;
      }
      a {
        color: $lavender !important;
        padding-right: 7px;
        text-decoration: none;
        &.is-active {
          color: $obMainMenu-middle_right_bill_info_is_active !important;
        }
      }
    }
  }
  .middle-menu-button {
    align-items: center;
    cursor: pointer;
    display: flex;
    flex-direction: row;
    justify-content: center;
    margin: 0;
    padding: 0 10px;
    background: none;
    border: none;
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 12px;
    line-height: 15px;
    letter-spacing: 0.2px;
    color: $lavender;
    outline: none;
    white-space: nowrap;
    border-width: 3px 0 2px 0;
    border-style: solid;
    border-color: transparent;
    opacity: 0.7;
    &.is-active {
      opacity: 1;
      outline: none;
      border-bottom-color: $obMainMenu-middle-button_active-border
    }
    &.--level-2 {
      text-transform: uppercase;
      height: 100%;
    }
    &:hover {
      opacity: 1;
    }
  }
  .hidden-items {
    position: relative;
    display: flex;
    flex-direction: column;
    justify-content: center;
    font-family: Roboto, sans-serif;
    cursor: pointer;
    margin: 0 10px;
    &__label {
      display: flex;
      align-items: center;
      color: white;
      font-size: 12px;
      line-height: 15px;
      width: 40px;
      .icon {
        margin-left: 3px;
      }
    }

    &__container {
      position: absolute;
      top: 25px;
      left: -140px;
      width: 200px;
      color: $lavender;
      box-shadow: 0px 8px 20px rgba($color-text-base, 0.5);

      &-row {
        display: flex;
        justify-content: flex-start;
        align-items: center;
        background: $color-blue-smalt;
        padding: 12px 20px 12px 20px;
        &:hover {
          background: $deep-blue;
        }
      }
    }
  }

  .action-button-container {
    display: flex;
    justify-content: center;
    align-items: center;
    margin-right: 9px;
    & + .border-container {
      margin-left: 11px;
    }
    &::v-deep {
      .ob-button-container {
        height: 26px;
      }
    }
  }
  .ob-button-container {
    &.primary-success-type{
      color: $topMenuTextHover;
    }
  }
</style>
